/**
 * @file lagoon/utils/sdn_factory.hpp
 * @brief Script-parsing framework polymorphic factory implementation
 *
 *  Copyright 2008-2010 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef LAGOON_UTILS_SDN_FACTORY_1011291729_HPP
#define LAGOON_UTILS_SDN_FACTORY_1011291729_HPP

#include <lagoon/config.hpp>
#include <lagoon/lagoon_fwd.hpp>
#include <lagoon/utils.hpp>
#include <lagoon/interfaces.hpp>
#include <lagoon/polymorph_factory.hpp>

#include <mirror/utils/sdn_factory.hpp>
// Script-parsing factory-related
#include <lagoon/utils/sdn_factory/utils.hpp>
#include <lagoon/utils/sdn_factory/manager.hpp>
#include <lagoon/utils/sdn_factory/composite.hpp>
#include <lagoon/utils/sdn_factory/arrayer.hpp>
#include <lagoon/utils/sdn_factory/manufacturer.hpp>
#include <lagoon/utils/sdn_factory/suppliers.hpp>
#include <lagoon/utils/sdn_factory/enumerator.hpp>
#include <lagoon/utils/sdn_factory/builder.hpp>

LAGOON_NAMESPACE_BEGIN

LAGOON_NAMESPACE_END

#endif //include guard

