#!/bin/bash
# Copyright 2008-2010 Matus Chochlik. Distributed under the Boost
# Software License, Version 1.0. (See accompanying file
# LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# Helper utility that extracts all header files included directly or
# indirectly by the files input read from the standard input.
# The search for indirect includes is performed in files found
# in directories passed as arguments, except the first one which
# is treated as the path to a temporary file.
#
temp_file=$1
[[ -f ${temp_file} ]] || touch ${temp_file}
#
while read input_file
do
	if [ $(grep -c -e "${input_file}" < ${temp_file}) -eq 0 ]
	then
		echo "${input_file}" >> ${temp_file}
		sed_filter='s/\s*#\s*include\s*[<"]\([^>"]\+\)[>"]/\1/p'
		sed -n "$sed_filter" < ${input_file}
		sed -n "$sed_filter" < ${input_file} |
		while read header_file
		do
			for search_dir
			do if [ -f ${search_dir}/${header_file} ]
			then echo "${search_dir}/${header_file}"
			fi
			done
		done | $0 $*
	fi
done
